clear all; close all;

m=0.5; h=0.5; k=0.6;

A=[0 0 0 0 0 1 0 0 0 0
   0 0 0 0 0 0 1 0 0 0
   0 0 0 0 0 0 0 1 0 0
   0 0 0 0 0 0 0 0 1 0
   0 0 0 0 0 0 0 0 0 1
   -2*k/m k/m 0 0 0 -h/m 0 0 0 0
   k/m -2*k/m k/m 0 0 0 -h/m 0 0 0
   0 k/m -2*k/m k/m 0 0 0 -h/m 0 0 
   0 0 k/m -2*k/m k/m 0 0 0 -h/m 0 
   0 0 0 k/m -k/m 0 0 0 0 -h/m];

b=[0 0 0 0 0 0 0 0 0 1/m]';

c=[0 0 0 0 1 0 0 0 0 0];

autovalori_non_regolato=eig(A);
max_real_autovalori=max(real(autovalori_non_regolato));
Td=-1/max_real_autovalori;
Tr_non_regolato=5*Td
pause;

O=obsv(A,c);
determinante_osservabilita=det(O)
pause;

R=ctrb(A,b);
determinante_raggiungibilita=det(R)
pause;

riduzione=5; % fattore di riduzione del tempo di risposta (p.e, se posto a 5 il tempo di risposta del sistema regolato è pari a 1/5 di quello non regolato)

reale_autovalori_regolato=riduzione*real(autovalori_non_regolato);
immag_autovalori_regolato=imag(autovalori_non_regolato);
autovalori_regolato=reale_autovalori_regolato+i*immag_autovalori_regolato;
max_real_autovalori=max(real(autovalori_regolato));
Td=-1/max_real_autovalori;
Tr_regolato=5*Td
pause;

L=acker(A',-c',autovalori_regolato)'
pause;

K=acker(A,-b,autovalori_regolato)
pause;

% simulazione
% matrici sistema regolato (vs: x ed e con e=x_hat-x)
AREG=[A+b*K b*K;zeros(10,10) A+L*c];
bREG=[b;zeros(10,1)];
% valuto le posizioni di tutti i piani
cTOT=[1 0 0 0 0 0 0 0 0 0
      0 1 0 0 0 0 0 0 0 0
      0 0 1 0 0 0 0 0 0 0
      0 0 0 1 0 0 0 0 0 0
      0 0 0 0 1 0 0 0 0 0
      A(10,:)];  % accelerazione ultimo piano NON regolato
AbK=A+b*K; bK=b*K;
cTOTREG=[1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      AbK(10,:) bK(10,:)]; % accelerazione ultimo piano regolato
t=[0:0.1:50];
u=zeros(size(t));
xin=[1/5 2/5 3/5 4/5 5/5 0 0 0 0 0];
xinREG=[1/5 2/5 3/5 4/5 5/5 0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 ]; % errore di ricostruzione inizialmente nullo 
sistema_non_regolato=ss(A,b,cTOT,0);
sistema_regolato=ss(AREG,bREG,cTOTREG,0);
pos_piani_non_regolato=lsim(sistema_non_regolato,u,t,xin);
pos_piani_regolato=lsim(sistema_regolato,u,t,xinREG);

% Simulazione stilizzata
figure; hold on;
y0=0*ones(size(t));
y1=1*ones(size(t));
y2=2*ones(size(t));
y3=3*ones(size(t));
y4=4*ones(size(t));
y5=5*ones(size(t));
for k = 5:length(t)
    subplot(1,2,1);plot([u(k) pos_piani_non_regolato(k,1) pos_piani_non_regolato(k,2) pos_piani_non_regolato(k,3) pos_piani_non_regolato(k,4) pos_piani_non_regolato(k,5)],[y0(k) y1(k) y2(k) y3(k) y4(k) y5(k)],'-k','LineWidth',3); axis([-2 2 0 5]);
    subplot(1,2,2);plot([u(k) pos_piani_regolato(k,1) pos_piani_regolato(k,2) pos_piani_regolato(k,3) pos_piani_regolato(k,4) pos_piani_regolato(k,5)],[y0(k) y1(k) y2(k) y3(k) y4(k) y5(k)],'-k','LineWidth',3); axis([-2 2 0 5]);
    pause(0.001);
    clf;
end
pause;
close;

figure(1); % posizione e accelerazione ultimo piano
subplot(2,2,1); plot(t,pos_piani_non_regolato(:,5)); xlabel('t'); ylabel('posizione ultimo piano'); title('posizione NON regolato'); % axis([0 50 -1 2]);
subplot(2,2,3); plot(t,pos_piani_regolato(:,5)); xlabel('t'); ylabel('posizione ultimo piano'); title('posizione regolato'); % axis([0 50 -1 2]);
subplot(2,2,2); plot(t,pos_piani_non_regolato(:,6)); xlabel('t'); ylabel('accelerazione ultimo piano'); title('accelerazione NON regolato'); % axis([0 50 -1 2]);
subplot(2,2,4); plot(t,pos_piani_regolato(:,6)); xlabel('t'); ylabel('accelerazione ultimo piano'); title('accelerazione regolato'); % axis([0 50 -1 2]);
pause;
close;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% per provare ad eliminare le oscillazioni nel sistema regolato, determino ora K e L di modo che il sistema regolato abbia tutti gli autovalori reali
% NOTA: acker non funziona bene con autovalori coincidenti!
% ci saranno delle sovraelongazioni contenute ma realizzabili solo con
% accelerazioni dell'ultimo piano troppo importanti
lD=-5/Tr_regolato
pause;
autovalori_regolato_NEW=[lD lD-0.5*1 lD-0.5*2 lD-0.5*3 lD-0.5*4 lD-0.5*5 lD-0.5*6 lD-0.5*7 lD-0.5*8 lD-0.5*9]'
pause
L_NEW=acker(A',-c',autovalori_regolato_NEW)'
pause;
K_NEW=acker(A,-b,autovalori_regolato_NEW)
pause;
% simulazione con le nuove L e K
% matrici sistema regolato
AREG_NEW=[A+b*K_NEW b*K_NEW;zeros(10,10) A+L_NEW*c];
bREG_NEW=[b;zeros(10,1)];
% valuto le posizioni di tutti i piani
cTOT=[1 0 0 0 0 0 0 0 0 0
      0 1 0 0 0 0 0 0 0 0
      0 0 1 0 0 0 0 0 0 0
      0 0 0 1 0 0 0 0 0 0
      0 0 0 0 1 0 0 0 0 0
      A(10,:)];  % accelerazione ultimo piano NON regolato
AbK=A+b*K_NEW; bK=b*K_NEW;
cTOTREG=[1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
      AbK(10,:) bK(10,:)]; % accelerazione ultimo piano regolato
t=[0:0.1:50];
u=zeros(size(t));
xin=[1/5 2/5 3/5 4/5 5/5 0 0 0 0 0];
xinREG=[1/5 2/5 3/5 4/5 5/5 0 0 0 0 0   0 0 0 0 0 0 0 0 0 0 ]; % errore di ricostruzione inizialmente nullo 
sistema_non_regolato=ss(A,b,cTOT,0);
sistema_regolato_NEW=ss(AREG_NEW,bREG_NEW,cTOTREG,0);
pos_piani_non_regolato=lsim(sistema_non_regolato,u,t,xin);
pos_piani_regolato_NEW=lsim(sistema_regolato_NEW,u,t,xinREG);

% Simulazione stilizzata
figure; hold on;
y0=0*ones(size(t));
y1=1*ones(size(t));
y2=2*ones(size(t));
y3=3*ones(size(t));
y4=4*ones(size(t));
y5=5*ones(size(t));
for k = 5:length(t)
    subplot(1,2,1);plot([u(k) pos_piani_non_regolato(k,1) pos_piani_non_regolato(k,2) pos_piani_non_regolato(k,3) pos_piani_non_regolato(k,4) pos_piani_non_regolato(k,5)],[y0(k) y1(k) y2(k) y3(k) y4(k) y5(k)],'-k','LineWidth',3); axis([-2 2 0 5]);
    subplot(1,2,2);plot([u(k) pos_piani_regolato_NEW(k,1) pos_piani_regolato_NEW(k,2) pos_piani_regolato_NEW(k,3) pos_piani_regolato_NEW(k,4) pos_piani_regolato_NEW(k,5)],[y0(k) y1(k) y2(k) y3(k) y4(k) y5(k)],'-k','LineWidth',3); axis([-2 2 0 5]);
    pause(0.001);
    clf;
end
pause;
close;

figure(3); % posizione e accelerazione ultimo piano
subplot(2,2,1); plot(t,pos_piani_non_regolato(:,5)); xlabel('t'); ylabel('posizione ultimo piano'); title('posizione NON regolato'); % axis([0 50 -1 2]);
subplot(2,2,3); plot(t,pos_piani_regolato_NEW(:,5)); xlabel('t'); ylabel('posizione ultimo piano'); title('posizione regolato'); % axis([0 50 -1 2]);
subplot(2,2,2); plot(t,pos_piani_non_regolato(:,6)); xlabel('t'); ylabel('accelerazione ultimo piano'); title('accelerazione NON regolato'); % axis([0 50 -1 2]);
subplot(2,2,4); plot(t,pos_piani_regolato_NEW(:,6)); xlabel('t'); ylabel('accelerazione ultimo piano'); title('accelerazione regolato'); % axis([0 50 -1 2]);
pause;
close;

