function palace(opt)



% PALACE(OPT)

% Simulatore interattivo per la regolazione di un palazzo.



% Variabili di servizio

  larg=2;                                                   % SemiLarghezza dei palazzi

  dist=5;                                                     % SemiDistanza tra i palazzi

  smooth=5;                                                   % Grado di smoothness

  intens=0.1;                                                   % Intensita' del vento

  

% Variabili globali di comunicazione

  % Comuni                                                   

    global SIMRESULT;                                         % Risultato della simulazione

    global DATI;                                              % Dati di progetto Npiani Mpiano Kpiano Hpiano

    global main_fig;                                          % Handlers figura principale

    global chmode_pop;                                        % Handlers popup di chmode        



  % Simulazione

    global pal;                                               % Handlers per i palazzi

    global simul_ax;                                          % Handlers assi dei palazzi 

    global simul_edit;                                        % Handlers finestre di edit per numero piani massa, coefficente elastico e di attrito viscoso, autovalori e tempo reazione, vettore dei guadagni

    global simul_txt;                                         % Handlers testo in modalita' simulazione

    global control_but;                                       % Handlers bottoni di simula stop e play

    global rec_slide;                                         % Handlers slider di recording

  

  % Analisi

    global ana_ax;                                            % Handlers assi di uscita non regolata uscita regolata e attuazione

    global h_plot;                                            % Handlers per i plot

    global pop_exit;                                          % Handlers popup per selezione uscita

    global ana_txt;                                           % Handlers testo in modalita' analisi

    global ana_frm;                                           % Handlers frames posizione velocita' accellerazione

    global ana_rad;                                           % Handlers radiobut posizione velocita' accellerazione normalizzazione grid



if nargin==0, % Se chiamato senza argomenti inizializza il programma

   % Inizializzazione

     if ~figflag('Regolazione Palazzo',0), % Controlla che il programma non sia mai stato inizializzato

        % Qualcosa con cui iniziare, carica l'ultima simulazione che e' stata effettuata

          load palace.mat;                                                  % In questo modo vengono caricati DATI e SIMRESULT

          [m n]=size(SIMRESULT);

        % Variabili per la creazione dell'interfaccia

            baseax=4/5;                              % Largezza assi dove risiedono i due palazzi

            baseframe=1/5;                           % Largezza frame dei controlli

            height=1/36;                             % Unita' normalizzata di altezza

            large=baseframe/16;                      % Unita' normalizzata di larghezza nella frame

            % Posizioni degli oggetti

            WINDOWS=[...

                     % Comune

                       % Figura

                         0 0 1 1; ...                                       %1

                       % Frames

                         baseax 1/40 baseframe 38/40; ...                   %2

                       % Popup menus (simulazione/analisi)

                         baseax+4*large 34*height 8*large 1*height; ...     %3

                       % Buttons (uscita)

                         baseax+1*large 1*height 3*large 1*height; ...      %4

                     % Finestra Simulazione

                       % axes (quello dei palazzi) 

                         0 0 4/5 1; ...                                     %5

                       % Testi (nell'ordine: "Dati di palazzo", "N piani", "M piano", "K piano", "H piano", "Dati di progetto", "Lt", "Tr", "Risultato", "Kt", "Controlli Simulazione")

                         baseax+3*large 31*height 10*large 1*height; ...    %6

                         baseax+1*large 29*height 4*large 1*height; ...

                         baseax+1*large 27*height 4*large 1*height; ...

                         baseax+1*large 25*height 4*large 1*height; ...

                         baseax+1*large 23*height 4*large 1*height; ...

                         baseax+3*large 20*height 10*large 1*height; ...

                         baseax+1*large 18*height 4*large 1*height; ...

                         baseax+1*large 16*height 4*large 1*height; ...

                         baseax+3*large 13*height 10*large 1*height; ...

                         baseax+1*large 11*height 4*large 1*height; ...

                         baseax+3*large  8*height 10*large 1*height; ...    %16

                       % Campi Edit (nell'ordine: Npiani, Mpiano, Kpiano, Hpiano, Lt, Tr, Kt)

                         baseax+6*large 29*height 8*large 1*height; ...     %17

                         baseax+6*large 27*height 8*large 1*height; ...

                         baseax+6*large 25*height 8*large 1*height; ...

                         baseax+6*large 23*height 8*large 1*height; ...

                         baseax+6*large 18*height 8*large 1*height; ...

                         baseax+6*large 16*height 8*large 1*height; ...

                         baseax+6*large 11*height 8*large 1*height; ...     %23

                       % Buttons (nell'ordine: Simula, stop, play)

                         baseax+6*large  6*height 4*large 1*height; ...     %24

                         baseax+1*large  4*height 2*large 1*height; ...

                         baseax+13*large 4*height 2*large 1*height; ...     %26

                       % Sliders (slider di registrazione)

                         baseax+4*large  4*height 8*large 1*height; ...     %27

                     % Finestra Analisi

                       % axes (nell'ordine: Uscita non regolata, uscita regolata, attuazione)

                         2/35 2/3+2/40 4/5-2/30 1/3-3/40; ...               %28

                         2/35 1/3+2/40 4/5-2/30 1/3-3/40; ...

                         2/35 2.1/40     4/5-2/30 1/3-3/40; ...             %30

                       % Testi (nell'ordine: "Uscita", "Derivate")

                         baseax+3*large 31*height 10*large 1*height; ...    %31

                         baseax+3*large 26*height 10*large 1*height; ...    %32

                       % Frames (nell'ordine: Colore posizione, Colore velocita', Colore accellerazione)

                         baseax+10*large 24*height 4*large 1*height; ...    %33

                         baseax+10*large 22*height 4*large 1*height; ...

                         baseax+10*large 20*height 4*large 1*height; ...    %35

                       % Radio Buttons (nell'ordine: Posizione, Velocita', Accellerazione, Normalizzazione, Grid)

                         baseax+1*large 24*height 6*large 1*height; ...     %36

                         baseax+1*large 22*height 6*large 1*height; ...

                         baseax+1*large 20*height 6*large 1*height; ...

                         baseax+1*large 18*height 6*large 1*height; ...

                         baseax+1*large 16*height 6*large 1*height; ...     %40

                       % Popup menu (Scelta uscita)

                         baseax+4*large 29*height 8*large 1*height; ...     %41

                    ];

          % Colori per gli oggetti   

          COLOR=[...

                 0 0 0; ...           % Nero

                 1 1 1; ...           % Bianco

                 0.5 0.5 0.5; ...     % Un bel grigio

                 1 1 0; ...           % Giallo

                ];



          % Stringhe opzioni dei popup menu

          modestr=[...

                   'Simulazione';...

                   'Analisi    ';...

                  ];



          outstr=[...

                  'Ultimo Piano';...

                  'Baricentro  ';...

                 ];



          % Creazione degli oggetti

          % FIGURA PRINCIPALE

          main_fig=figure(...
                          'Units','normal', ...
                          'Position',WINDOWS(1,:),...
                          'Color',COLOR(2,:), ...
                          'Resize','off', ...
                          'Name','Regolazione Palazzo', ...
                          'NumberTitle','off', ...
                          'MenuBar','none', ...
                          'Interruptible','off', ...
                          'Visible','off' ...
                         );



          % FRAME DEI COMANDI

          uicontrol(...
                    'Style','frame', ...
                    'Units','normal', ...
                    'ForeGroundColor',COLOR(2,:), ...
                    'BackGroundColor',COLOR(3,:), ...
                    'Position',WINDOWS(2,:) ...
                   );


          % POPUP MENU: Modo Simulazione/Analisi

          chmode_pop=uicontrol(...
                               'Style','PopUpMenu', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(1,:), ...
                               'BackGroundColor',COLOR(2,:), ...
                               'CallBack','palace(''chmode'')', ...
                               'String',modestr, ...
                               'Position',WINDOWS(3,:), ...
                               'Value',1 ...
                              );



          % PUSH BUTTON: Uscita

          uicontrol(...
                    'Style','Pushbutton', ...
                    'Units','normal', ...
                    'CallBack','palace(''exit'');', ...
                    'String','Exit', ...
                    'Position',WINDOWS(4,:) ...
                   );



          % ASSE PER LA FINESTRA DI SIMULAZIONE

          simul_ax=axes(...
                        'Units','normal', ...
                        'Position',WINDOWS(5,:),...
                        'XGrid','off','XLimMode','manual','XLim',[-1.5*(larg+dist) 1.5*(larg+dist)], ...
                        'YGrid','off','YLimMode','manual','YLim',[-0.25 1.25], ...
                        'Box','on', ...
                        'Visible','off' ...
                       );



          % TESTO: "Dati di Palazzo"

          simul_txt(1)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(4,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(6,:), ...
                                 'String','Dati di Palazzo' ...
                                );



          % TESTO: "N piani" 

          simul_txt(2)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(2,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(7,:), ...
                                 'String','N piani' ...
                                );



          % TESTO: "M piano"

          simul_txt(3)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(2,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(8,:), ...
                                 'String','M piano' ...
                                );



          % TESTO: "K piano"

          simul_txt(4)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(2,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(9,:), ...
                                 'String','K piano' ...
                                );



          % TESTO: "H piano"

          simul_txt(5)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(2,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(10,:), ...
                                 'String','H piano' ...
                                );



          % TESTO: "Dati di Progetto"

          simul_txt(6)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(4,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(11,:), ...
                                 'String','Dati di Progetto' ...
                                );



          % TESTO: "Lt"

          simul_txt(7)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(2,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(12,:), ...
                                 'String','Lt' ...
                                );



          % TESTO: "Tr"

          simul_txt(8)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(2,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(13,:), ...
                                 'String','Tr' ...
                                );



          % TESTO: "Risultato"

          simul_txt(9)=uicontrol(...
                                 'Style','text', ...
                                 'Units','normal', ...
                                 'ForeGroundColor',COLOR(4,:), ...
                                 'BackGroundColor',COLOR(3,:), ...
                                 'Position',WINDOWS(14,:), ...
                                 'String','Risultato' ...
                                );



          % TESTO: "Kt"

          simul_txt(10)=uicontrol(...
                                  'Style','text', ...
                                  'Units','normal', ...
                                  'ForeGroundColor',COLOR(2,:), ...
                                  'BackGroundColor',COLOR(3,:), ...
                                  'Position',WINDOWS(15,:), ...
                                  'String','Kt' ...
                                 );



          % TESTO: "Controlli Simulazione"

          simul_txt(11)=uicontrol(...
                                  'Style','text', ...
                                  'Units','normal', ...
                                  'ForeGroundColor',COLOR(4,:), ...
                                  'BackGroundColor',COLOR(3,:), ...
                                  'Position',WINDOWS(16,:), ...
                                  'String','Controlli Simulazione' ...
                                 );



          % EDIT: Npiani che finisce in DATI(1)

          simul_edit(1)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(17,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String',num2str(DATI(1)) ...
                                 );



          % EDIT: Mpiano che finisce in DATI(2)

          simul_edit(2)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(18,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String',num2str(DATI(2)) ...
                                 );



          % EDIT: Kpiano che finisce in DATI(3)

          simul_edit(3)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(19,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String',num2str(DATI(3)) ...
                                 );



          % EDIT: Hpiano che finisce in DATI(4)

          simul_edit(4)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(20,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String',num2str(DATI(4)) ...
                                 );



          % EDIT: Lt che finisce in [DATI(5) ... DATI(5+2*DATI(1)-1)]

          simul_edit(5)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(21,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String','2*real(lambdanreg)+i*imag(lambdanreg)' ...
                                 );



          % EDIT: Tr che finisce in DATI(5+2*DATI(1))

          simul_edit(6)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(22,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String',num2str(DATI(5+2*DATI(1))) ...
                                 );



          % EDIT: Kt che finisce in [DATI(5+2*DATI(1)+1) ... DATI(5+4*DATI(1))]

          simul_edit(7)=uicontrol(...
                                  'Units','normal', ...
                                  'Position',WINDOWS(23,:),...
                                  'BackGroundColor',COLOR(2,:), ...
                                  'ForeGroundColor',COLOR(1,:), ...
                                  'Style','edit', ...
                                  'Max',1, ...
                                  'String',mat2str(DATI(5+2*DATI(1)+1:5+4*DATI(1))) ...
                                 );



          % PUSH_BUTTON: Simula

          control_but(1)=uicontrol(...
                                   'Style','Pushbutton', ...
                                   'Units','normal', ...
                                   'CallBack','palace(''simula'');', ...
                                   'String','Simula', ...
                                   'Position',WINDOWS(24,:) ...
                                  );


          % PUSH_BUTTON: Stop

          control_but(2)=uicontrol(...
                                   'Style','Pushbutton', ...
                                   'Units','normal', ...
                                   'CallBack','palace(''stop'');', ...
                                   'String','o', ...
                                   'Value',1, ...
                                   'Position',WINDOWS(25,:) ...
                                  );



          % PUSH_BUTTON: Play

          control_but(3)=uicontrol(...
                                   'Style','Pushbutton', ...
                                   'Units','normal', ...
                                   'CallBack','palace(''play'');', ...
                                   'String','>', ...
                                   'Position',WINDOWS(26,:) ...
                                  );



          % SLIDER: Rec Position

          rec_slide=uicontrol(...
                              'Style','slider', ...
                              'Units','normal', ...
                              'CallBack','palace(''slide'');', ...
                              'Position',WINDOWS(27,:), ...
                              'Max',m,...
                              'Min',1,...
                              'Value',1 ...
                             );



          % ASSE: Uscita non regolata

          ana_ax(1)=axes(...
                         'Units','normal', ...
                         'Position',WINDOWS(28,:),...
                         'Color',COLOR(2,:), ...
                         'XGrid','on','XColor',COLOR(1,:),'XLimMode','auto', ...
                         'YGrid','on','YColor',COLOR(1,:),'YLimMode','auto', ...
                         'Box','on', ...
                         'Visible','off' ...
                        );

          xlabel('Tempo','Parent',ana_ax(1));

          ylabel('Y non regolata','Parent',ana_ax(1));



          % ASSE: Uscita regolata

          ana_ax(2)=axes(...
                         'Units','normal', ...
                         'Position',WINDOWS(29,:),...
                         'Color',COLOR(2,:), ...
                         'XGrid','on','XColor',COLOR(1,:),'XLimMode','auto', ...
                         'YGrid','on','YColor',COLOR(1,:),'YLimMode','auto', ...
                         'Box','on', ...
                         'Visible','off' ...
                        );

          xlabel('Tempo','Parent',ana_ax(2));

          ylabel('Y regolata','Parent',ana_ax(2));



      % ASSE: Attuazione

          ana_ax(3)=axes(...
                         'Units','normal', ...
                         'Position',WINDOWS(30,:),...
                         'Color',COLOR(2,:), ...
                         'XGrid','on','XColor',COLOR(1,:),'XLimMode','auto', ...
                         'YGrid','on','YColor',COLOR(1,:),'YLimMode','auto', ...
                         'Box','on', ...
                         'Visible','off' ...
                        );

          xlabel('Tempo','Parent',ana_ax(3));

          ylabel('U','Parent',ana_ax(3));



      % TESTO: "Uscita"

          ana_txt(1)=uicontrol(...
                               'Style','text', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(4,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'Position',WINDOWS(31,:), ...
                               'String','Uscita', ...
                               'Visible','off' ...
                              );



      % TESTO: "Derivate"

          ana_txt(2)=uicontrol(...
                               'Style','text', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(4,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'Position',WINDOWS(32,:), ...
                               'String','Derivate', ...
                               'Visible','off' ...
                              );



      % FRAME: Colore Posizione

          ana_frm(1)=uicontrol(...
                               'Style','frame', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor','r', ...
                               'ButtonDownFcn','palace(''poscolor'');', ...
                               'Position',WINDOWS(33,:), ...
                               'Visible','off' ...
                              );



      % FRAME: Colore Posizione

          ana_frm(2)=uicontrol(...
                               'Style','frame', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor','g', ...
                               'ButtonDownFcn','palace(''velcolor'');', ...
                               'Position',WINDOWS(34,:), ...
                               'Visible','off' ...
                              );



      % FRAME: Colore Accelerazione

          ana_frm(3)=uicontrol(...
                               'Style','frame', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor','k', ...
                               'ButtonDownFcn','palace(''acccolor'');', ...
                               'Position',WINDOWS(35,:), ...
                               'Visible','off' ...
                              );



          % RADIO BUTTON: Posizione

          ana_rad(1)=uicontrol(...
                               'Style','RadioButton', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'CallBack','palace(''plot'');', ...
                               'String','Posizione', ...
                               'Position',WINDOWS(36,:), ...
                               'Value',1, ...
                               'Visible','off' ...
                              );



          % RADIO BUTTON: Velocita'

          ana_rad(2)=uicontrol(...
                               'Style','RadioButton', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'CallBack','palace(''plot'');', ...
                               'String','Velocit', ...
                               'Position',WINDOWS(37,:), ...
                               'Value',1, ...
                               'Visible','off' ...
                              );



          % RADIO BUTTON: Accelerazione

          ana_rad(3)=uicontrol(...
                               'Style','RadioButton', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'CallBack','palace(''plot'');', ...
                               'String','Acceller.', ...
                               'Position',WINDOWS(38,:), ...
                               'Value',1, ...
                               'Visible','off' ...
                              );



      % RADIO BUTTON: Normalizzazione

          ana_rad(4)=uicontrol(...
                               'Style','RadioButton', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'CallBack','palace(''plot'');', ...
                               'String','Normal.', ...
                               'Position',WINDOWS(39,:), ...
                               'Value',1, ...
                               'Visible','off' ...
                              );



          % RADIO BUTTON: Grid

          ana_rad(5)=uicontrol(...
                               'Style','RadioButton', ...
                               'Units','normal', ...
                               'ForeGroundColor',COLOR(2,:), ...
                               'BackGroundColor',COLOR(3,:), ...
                               'CallBack','palace(''grid'');', ...
                               'String','Grid', ...
                               'Position',WINDOWS(40,:), ...
                               'Value',1, ...
                               'Visible','off' ...
                              );



      % POPUP MENU: Uscita

          pop_exit=uicontrol(...
                             'Style','PopUpMenu', ...
                             'Units','normal', ...
                             'ForeGroundColor',COLOR(1,:), ...
                             'BackGroundColor',COLOR(2,:), ...
                             'CallBack','palace(''plot'')', ...
                             'String',outstr, ...
                             'Position',WINDOWS(41,:), ...
                             'Value',1, ...
                             'Visible','off' ...
                            );



          % Disegna i palazzi

            axes(simul_ax); % Asse dei palazzi asse corrente

            pal(1)=patch([-(1.5*larg+dist) -(1.5*larg+dist) (1.5*larg-dist) (1.5*larg-dist)],[0 -0.1 -0.1 0],[0.25 0.25 0.25],'EdgeColor','none');  % base pal 1

            % pal(2)=patch([0 0],[1 1],[0.5 0.1 0],'erasemode','xor','EdgeColor','r','LineWidth',2);                                                % pal 1, solido

            pal(2)=patch([0 0],[1 1],'w','erasemode','xor','EdgeColor','r','facecolor','none','LineWidth',2);                                       % pal 1, frame

            pal(3)=patch([(1.5*larg+dist) (1.5*larg+dist) (-1.5*larg+dist) (-1.5*larg+dist)],[0 -0.1 -0.1 0],[0.25 0.25 0.25],'EdgeColor','none');  % base pal 2

            % pal(4)=patch([0 0],[1 1],[0.5 0.1 0],'erasemode','xor','EdgeColor','g','LineWidth',2);                                                % pal 2, solido

            pal(4)=patch([0 0],[1 1],'w','erasemode','xor','EdgeColor','g','facecolor','none','LineWidth',2);                                       % pal 1, frame

            palace('slide');

          

          % Disegna i plot di analisi 

            axes(ana_ax(1)); % Asse uscita non regolata asse corrente

            h_plot(1)=line([0 1],[1 5],'color','r','LineWidth',2,'visible','off'); % Pos non reg

            h_plot(2)=line([0 2],[1 6],'color','g','LineWidth',2,'visible','off'); % Vel non reg

            h_plot(3)=line([0 3],[1 7],'color','k','LineWidth',2,'visible','off'); % Acc non reg

            axes(ana_ax(2)); % Asse uscita regolata asse corrente

            h_plot(4)=line([0 1],[1 5],'color','r','LineWidth',2,'visible','off'); % Pos reg

            h_plot(5)=line([0 2],[1 6],'color','g','LineWidth',2,'visible','off'); % Vel reg

            h_plot(6)=line([0 3],[1 7],'color','k','LineWidth',2,'visible','off'); % Acc reg

            axes(ana_ax(3)); % Asse attuazione asse corrente

            h_plot(7)=line([0 1],[0 1],'color','m','LineWidth',2,'visible','off'); % Out



          % Rende visibile la figura principale solo dopo aver finito la costruzione

            set(main_fig,'visible','on')  ;

     else

        return;

     end;

elseif strcmp(opt,'chmode'),   % Servizi



      if get(chmode_pop,'value')==1,

%         set(main_fig,'visible','off')  ; % Decommentare se durante i cambi fa flicker

         set([pal simul_edit simul_txt control_but rec_slide],'visible','on');

         set([ana_ax h_plot pop_exit ana_txt ana_frm ana_rad],'visible','off');

         palace('slide');

%         set(main_fig,'visible','on')  ;  % Decommentare se durante i cambi fa flicker

      else,

%         set(main_fig,'visible','off')  ; % Decommentare se durante i cambi fa flicker

         set([pal simul_edit simul_txt control_but rec_slide],'visible','off');

         set([ana_ax h_plot pop_exit ana_txt ana_frm ana_rad],'visible','on');

         palace('plot');

%         set(main_fig,'visible','on')  ;  % Decommentare se durante i cambi fa flicker

      end;

      return;



elseif strcmp(opt,'exit'),



% Decommentare la prima riga quando il programma sara' finito

      save palace.mat SIMRESULT DATI;                                 % Salva il risultato dell'ultima simulazione

      close(main_fig);                            % Chiude la figura

      clear global SIMRESULT;                                         % Cancella Risultato della simulazione

      clear global DATI;                                              % Cancella Dati di simulazione

      clear global main_fig;                                          % Cancella Handlers figura principale

      clear global chmode_pop;                                        % Cancella Handlers popup di chmode        

      clear global pal;                                               % Cancella Handlers per i palazzi

      clear global simul_ax;                                          % Cancella Handlers assi dei palazzi 

      clear global simul_edit;                                        % Cancella Handlers finestre di edit per numero piani massa, coefficente elastico e di attrito viscoso, autovalori e tempo reazione, vettore dei guadagni

      clear global simul_txt;                                         % Cancella Handlers testo in modalita' simulazione

      clear global control_but;                                       % Cancella Handlers bottoni di simula stop e play

      clear global rec_slide;                                         % Cancella Handlers slider di recording

      clear global ana_ax;                                            % Cancella Handlers assi di uscita non regolata uscita regolata e attuazione

      clear global h_plot;                                            % Cancella Handlers per i plot

      clear global pop_exit;                                          % Cancella Handlers popup per selezione uscita

      clear global ana_txt;                                           % Cancella Handlers testo in modalita' analisi

      clear global ana_frm;                                           % Cancella Handlers frames posizione velocita' accellerazione

      clear global ana_rad;                                           % Cancella Handlers radiobut posizione velocita' accellerazione normalizzazione grid

      return;



elseif strcmp(opt,'simula'),



      % Si riavvolge il nastro

        set(rec_slide,'value',1);

      % Raccolta dati

        DATI(1)=str2num(get(simul_edit(1),'string'));                   % Numero piani

        DATI(2)=str2num(get(simul_edit(2),'string'));                   % Massa di un piano

        DATI(3)=str2num(get(simul_edit(3),'string'));                   % Coefficente elastico di un piano

        DATI(4)=str2num(get(simul_edit(4),'string'));                   % Coefficente di attrito viscoso di un piano

        % Gli autovalori vengono raccolti dopo in maniera tale da poter sfruttare la conoscenza degli autovalori del sistema non regolato

        DATI(5+2*DATI(1))=str2num(get(simul_edit(6),'string'));         % Tempo di raffica

      % Qualche nome piu' significativo

        N=DATI(1);

        M=DATI(2);

        K=DATI(3);

        H=DATI(4);

        Tr=DATI(5+2*DATI(1));

      % Costruzione Matrici A,B

        A=zeros(2*N,2*N);

        A([1:N],[N+1:2*N])=eye(N);

        A([N+1:2*N],[N+1:2*N])=-H/M*eye(N);

        A([N+1:2*N],[1:N])=-2*K/M*eye(N);

        A(2*N,N)=-K/M;

        for ind=1:(N-1),

            A(N+ind,1+ind)=K/M;

            A(N+1+ind,ind)=K/M;

        end;

        B=zeros(2*N,1);

        B(2*N)=1/M;

      % Autovalori sistema non regolato

        lambdanreg=esort(eig(A));                                      % Il primo e' il piu' lento l'ultimo e' il piu' veloce

        % Ora si possono raccogliere gli autovalori richiesti

          DATI(5:5+2*DATI(1)-1)=eval(get(simul_edit(5),'string'));     % Assegnamento degli autovalori

          lambdareg=esort(DATI(5:5+2*DATI(1)-1));                      % Un nome piu' decente

      % Determinazione tempo di campionamento e durata simulazione

        if min(abs(lambdanreg))<min(abs(lambdareg)),  % La dinamica piu' lenta del non regolato e' piu' lenta di quella piu' lenta del regolato

%            Tfin=Tr+3/min(abs(lambdanreg));
           Tfin=Tr-5/max(real(lambdanreg));

        else,

           Tfin=Tr+3/min(abs(lambdareg));

        end;

        if max(abs(lambdanreg))>max(abs(lambdanreg)), % La dinamica piu' veloce del non regolato e' piu' veloce di quella piu' veloce del regolato

           dt=1/(5*max(abs(lambdanreg)));

        else,

           dt=1/(5*max(abs(lambdareg)));

        end;

      % Determinazione del vettore dei pesi in retroazione

        Kt=acker(A,B,lambdareg);

      % Salva il risultato

        DATI(5+2*DATI(1)+1:5+4*DATI(1))=-Kt;    

      % Viene messo fuori il risultato

        set(simul_edit(7),'string',mat2str(DATI(5+2*DATI(1)+1:5+4*DATI(1)))); % Kt

      % Parametri per la simulazione grafica

        if N<9, ord=N; else, ord=9; end;

        npoint=smooth*(N+1);

        quota=linspace(0,1,N+1)';

        quotas=linspace(0,1,npoint)';

      % Tutto fermo all'inizio

        Xnr=zeros(1,2*N)';

        Xr= zeros(1,2*N)';

        SIMRESULT=[Xnr' Xr' 0 0];

      % Profilo della raffica di vento

        Braff=intens*[zeros(1,N) (1:N).^2]';

      % Gestione del registratore

        m=length(0:dt:Tfin);

        pos=0;

        set(rec_slide,'max',m);

      % Parte la simulazione

        for t=dt:dt:Tfin ,

            pos=pos+1;

            if t<Tr, eff=1; else, eff=0; end; % Raffica di vento fino a Tr

            % Integrazione di regolato e non regolato

            Xnr=Xnr+(A*Xnr+Braff*eff)*dt;

            Xr =Xr+((A-B*Kt)*Xr+Braff*eff)*dt;

            % Salvataggio del passo di integrazione

            SIMRESULT=[SIMRESULT; Xnr' Xr' Kt*Xr t];

            % Simulazione grafica

            xpal1=[0; Xnr(1:N)];

            xpal2=[0; Xr(1:N)];

            pp1=polyfit(quota,xpal1,ord);

            pp2=polyfit(quota,xpal2,ord);

            xpal1s=polyval(pp1,quotas);

            xpal2s=polyval(pp2,quotas);

            set(pal(2),'xdata',[xpal1s-dist-larg; xpal1s(npoint)+larg-dist; flipud(xpal1s)+larg-dist; xpal1s(1)-larg-dist],'ydata',[quotas; quotas(npoint); flipud(quotas); quotas(1)]);

            set(pal(4),'xdata',[xpal2s+dist-larg; xpal2s(npoint)+larg+dist; flipud(xpal2s)+larg+dist; xpal2s(1)-larg+dist],'ydata',[quotas; quotas(npoint); flipud(quotas); quotas(1)]);

            set(rec_slide,'value',pos);

            drawnow;

            if ~get(control_but(2),'value'), break; end;

        end;

      % Ripristina il bottone di stop

        set(control_but(2),'value',1);

      % Prima della fine vanno corretti gli estremi di registrazione

        [m n]=size(SIMRESULT);

        set(rec_slide,'value',1);

        set(rec_slide,'max',m);

        return;



elseif strcmp(opt,'play'),



      [m n]=size(SIMRESULT);

      pos=get(rec_slide,'value')-1;

      if DATI(1)<9, ord=DATI(1); else, ord=9; end;

      npoint=smooth*(DATI(1)+1);

      quota=linspace(0,1,DATI(1)+1)';

      quotas=linspace(0,1,npoint)';

      while(get(control_but(2),'value')&(pos<m)),

           pos=pos+1;

           xpal1=[0; SIMRESULT(pos,1:DATI(1))'];

           xpal2=[0; SIMRESULT(pos,2*DATI(1)+1:3*DATI(1))'];

           pp1=polyfit(quota,xpal1,ord);

           pp2=polyfit(quota,xpal2,ord);

           xpal1s=polyval(pp1,quotas);

           xpal2s=polyval(pp2,quotas);

           set(pal(2),'xdata',[xpal1s-dist-larg; xpal1s(npoint)+larg-dist; flipud(xpal1s)+larg-dist; xpal1s(1)-larg-dist],'ydata',[quotas; quotas(npoint); flipud(quotas); quotas(1)]);

           set(pal(4),'xdata',[xpal2s+dist-larg; xpal2s(npoint)+larg+dist; flipud(xpal2s)+larg+dist; xpal2s(1)-larg+dist],'ydata',[quotas; quotas(npoint); flipud(quotas); quotas(1)]);

           set(rec_slide,'value',pos);

           drawnow;

      end;

      % Ripristina il bottone di stop

      set(control_but(2),'value',1);

      return;



elseif strcmp(opt,'slide'),



      pos=get(rec_slide,'value');

      if DATI(1)<9, ord=DATI(1); else, ord=9; end;

      npoint=smooth*(DATI(1)+1);

      quota=linspace(0,1,DATI(1)+1)';

      quotas=linspace(0,1,npoint)';

      xpal1=[0; SIMRESULT(pos,1:DATI(1))'];

      xpal2=[0; SIMRESULT(pos,2*DATI(1)+1:3*DATI(1))'];

      pp1=polyfit(quota,xpal1,ord);

      pp2=polyfit(quota,xpal2,ord);

      xpal1s=polyval(pp1,quotas);

      xpal2s=polyval(pp2,quotas);

      set(pal(2),'xdata',[xpal1s-dist-larg; xpal1s(npoint)+larg-dist; flipud(xpal1s)+larg-dist; xpal1s(1)-larg-dist],'ydata',[quotas; quotas(npoint); flipud(quotas); quotas(1)]);

      set(pal(4),'xdata',[xpal2s+dist-larg; xpal2s(npoint)+larg+dist; flipud(xpal2s)+larg+dist; xpal2s(1)-larg+dist],'ydata',[quotas; quotas(npoint); flipud(quotas); quotas(1)]);

      drawnow;

      return;



elseif strcmp(opt,'poscolor'),



      oldcol=get(h_plot(1),'color');

      col=uisetcolor(oldcol,'Colore Posizioni');

      set(h_plot(1),'color',col);

      set(h_plot(4),'color',col);

      set(ana_frm(1),'BackGroundColor',col);

      return;



elseif strcmp(opt,'velcolor'),



      oldcol=get(h_plot(2),'color');

      col=uisetcolor(oldcol,'Colore Velocit');

      set(h_plot(2),'color',col);

      set(h_plot(5),'color',col);

      set(ana_frm(2),'BackGroundColor',col);

      return;



elseif strcmp(opt,'acccolor'),



      oldcol=get(h_plot(3),'color');

      col=uisetcolor(oldcol,'Colore Accellerazioni');

      set(h_plot(3),'color',col);

      set(h_plot(6),'color',col);

      set(ana_frm(3),'BackGroundColor',col);

      return;



elseif strcmp(opt,'plot'),



      [m n]=size(SIMRESULT);

      if get(pop_exit,'value')==1,

         out=SIMRESULT(:,[DATI(1) 3*DATI(1)]);

         outv=SIMRESULT(:,[2*DATI(1) 4*DATI(1)]);

      else,

         out(:,1)=mean(SIMRESULT(:,[1:DATI(1)])')';

         out(:,2)=mean(SIMRESULT(:,[2*DATI(1)+1:3*DATI(1)])')';

         outv(:,1)=mean(SIMRESULT(:,DATI(1)+1:2*DATI(1))')';

         outv(:,2)=mean(SIMRESULT(:,3*DATI(1)+1:4*DATI(1))')';

      end;

      outa=diff(outv)./diff([SIMRESULT(:,n) SIMRESULT(:,n)]);

      if get(ana_rad(4),'value')==1,

         out=[out(:,1)/max(abs(out(:,1))) out(:,2)/max(abs(out(:,2)))];

         outv=[outv(:,1)/max(abs(outv(:,1))) outv(:,2)/max(abs(outv(:,2)))];

         outa=[outa(:,1)/max(abs(outa(:,1))) outa(:,2)/max(abs(outa(:,2)))];

      end;

      if get(ana_rad(1),'value'),

         set(h_plot(1),'Xdata',SIMRESULT(:,n),'Ydata',out(:,1),'visible','on');

         set(h_plot(4),'Xdata',SIMRESULT(:,n),'Ydata',out(:,2),'visible','on');

      else,

         set(h_plot(1),'visible','off');

         set(h_plot(4),'visible','off');

      end;   

      if get(ana_rad(2),'value'),

         set(h_plot(2),'Xdata',SIMRESULT(:,n),'Ydata',outv(:,1),'visible','on');

         set(h_plot(5),'Xdata',SIMRESULT(:,n),'Ydata',outv(:,2),'visible','on');

      else,

         set(h_plot(2),'visible','off');

         set(h_plot(5),'visible','off');

      end;   

      if get(ana_rad(3),'value'),

         set(h_plot(3),'Xdata',SIMRESULT([1:(m-1)],n),'Ydata',outa(:,1),'visible','on');

         set(h_plot(6),'Xdata',SIMRESULT([1:(m-1)],n),'Ydata',outa(:,2),'visible','on');

      else,

         set(h_plot(3),'visible','off');

         set(h_plot(6),'visible','off');

      end;   

      set(h_plot(7),'Xdata',SIMRESULT(:,n),'Ydata',SIMRESULT(:,n-1),'visible','on');

      drawnow;

      return;



elseif strcmp(opt,'grid'),



      if get(ana_rad(5),'value')==1,

         set(ana_ax,'Xgrid','on','Ygrid','on');

      else,

         set(ana_ax,'Xgrid','off','Ygrid','off');

      end;

      return;



end;
